<app-navbar></app-navbar>

<div class="container-fluid">

    <div>
        <h2 style="margin: 20px 0px 0px 30px;">Cumplimiento diario</h2>
        <hr>
    </div>
    <div class="legend">
        <div class="legend-item">
            <div class="legend-square" style="background-color: rgb(187, 187, 187);"></div>
            <span>Planeado</span>
        </div>
        <div class="legend-item">
            <div class="legend-square" style="background-color: green;"></div>
            <span>Completado</span>
        </div>
    </div>
    <select name="mes" [(ngModel)]="mesSeleccionado" (change)="seleccionarMes()">
        <option value="0">Enero</option>
        <option value="1">Febrero</option>
        <option value="2">Marzo</option>
        <option value="3">Abril</option>
        <option value="4">Mayo</option>
        <option value="5">Junio</option>
        <option value="6">Julio</option>
        <option value="7">Agosto</option>
        <option value="8">Septiembre</option>
        <option value="9">Octubre</option>
        <option value="10">Noviembre</option>
        <option value="11">Diciembre</option>
    </select>
    <select name="anio" [(ngModel)]="anioSeleccionado" (change)="seleccionarMes()">
        <option value="2024">2024</option>
        <option value="2025">2025</option>
        <option value="2026">2026</option>
    </select>
    <div class="col-12 d-flex justify-content-end mb-3">
        <button class="btn btn-primary mr-3" (click)="abrirNuevaRocaModal()">Nueva Roca</button>
        <button class="btn btn-primary" (click)="abrirNuevaActividadModal()">Nueva Actividad</button>
    </div>

    <!-- <div class="table-responsive mt-2" style="max-height: 70vh;"> -->
    <div class="table-responsive mt-2">
        <table class="table table-bordered">
            <thead>
                <!-- <tr class="medio normal" style="position: sticky; top: 0;"> -->
                <tr class="medio normal" style="position: sticky; top: 0;">
                    <th>Quien</th>
                    <th>Tarea</th>
                    <th>Progreso</th>
                    <ng-container *ngFor="let fechas of diasMes">
                        <th class="fechas">{{fechas}}</th>
                    </ng-container>
                </tr>
            </thead>
            <tbody class="medio">
                <ng-container *ngFor="let roca of rocas[idUsuario]">
                    <tr>
                        <td [attr.colspan]="3 + +diasMes.length" class="titulo pointer"
                            (click)="abrirEditarRocaModal(roca)">
                            Roca: {{roca.nombreRoca}}</td>
                    </tr>
                    <ng-container *ngIf="actividades[idUsuario][roca.idRoca];">
                        <tr *ngFor="let act of actividades[idUsuario][roca.idRoca][0]">
                            <td style="justify-content: center;vertical-align: middle;"><img
                                    [src]="'http://localhost:8080/imgs/usuarios/' + roca.imagenUsuario"
                                    class="pfp d-none d-xl-block d-xxl-block"
                                    title="{{roca.nombreUsuario}} {{roca.apellidoUsuario}}">
                            </td>
                            <td (click)="abrirEditarActividadModal(act)" class="pointer"
                                title="{{act.nombreActividad}}">{{act.nombreActividad}}</td>
                            <td style="text-align: center; vertical-align: middle;">
                                {{porcentaje[idUsuario][act.idActividad] || 0}}%</td>
                            <ng-container *ngFor="let st of status[idUsuario][act.idActividad]; let i = index">
                                <td class="pointer" (click)="abrir(fechas[i], st, act)" [ngStyle]="{
                                'background-color': st == null ? 'white' : st == 'Planeado' ? 'rgb(187, 187, 187)' : 'green'
                              }"></td>
                            </ng-container>
                        </tr>
                    </ng-container>
                    <ng-container *ngIf="!actividades[idUsuario][roca.idRoca]">
                        <tr>
                            <td [attr.colspan]="3 + +diasMes.length"> Aún no hay actividades</td>
                        </tr>
                    </ng-container>
                </ng-container>
                <tr>
                    <td [attr.colspan]="3 + +diasMes.length" class="titulo normal">Actividades secundarias</td>
                </tr>
                <ng-container *ngIf="!actividadesSecundarias[idUsuario]">
                    <tr>
                        <td [attr.colspan]="3 + +diasMes.length"> Aún no hay actividades</td>
                    </tr>
                </ng-container>
                <ng-container *ngFor="let secundarias of actividadesSecundarias[idUsuario]">
                    <tr>
                        <td style="justify-content: center;vertical-align: middle;"><img
                                [src]="'http://localhost:8080/imgs/usuarios/' + rocas[idUsuario][0].imagenUsuario"
                                class="pfp d-none d-xl-block d-xxl-block"
                                title="{{rocas[idUsuario][0].nombreUsuario}} {{rocas[idUsuario][0].apellidoUsuario}}">
                        </td>
                        <td class="pointer" (click)="abrirEditarActividadModal(secundarias)">
                            {{secundarias.nombreActividad}}</td>
                        <td style="text-align: center;vertical-align: middle;">
                            {{porcentaje[idUsuario][secundarias.idActividad] || 0}}%</td>
                        <ng-container
                            *ngFor="let st of status[idUsuario]['Sin roca'][secundarias.idActividad]; let i = index">
                            <td class="pointer" (click)="abrir(fechas[i], st, secundarias)" [ngStyle]="{
                            'background-color': st == null ? 'white' : st == 'Planeado' ? 'rgb(187, 187, 187)' : 'green'
                          }"></td>
                        </ng-container>
                    </tr>
                </ng-container>
            </tbody>
        </table>
    </div>
    <hr>
    <div *ngIf="colaboradores && colaboradores.length > 1">
        <h2 class="mt-3">Equipo</h2>
        <ng-container *ngFor="let participantes of colaboradores">
            <hr>
            <div *ngIf="participantes.idUsuario != idUsuario">
                <h4>{{participantes.nombreUsuario}} {{participantes.apellidoUsuario}} - {{participantes.puestoUsuario}}
                </h4>
                <div class="table-responsive mt-2 normal">
                    <table class="table table-bordered">
                        <thead>
                            <tr>
                                <th>Quien</th>
                                <th>Tarea</th>
                                <th>Progreso</th>
                                <ng-container *ngFor="let fechas of diasMes">
                                    <th class="fechas">{{fechas}}</th>
                                </ng-container>
                            </tr>
                        </thead>
                        <tbody>
                            <ng-container *ngFor="let roca of rocas[participantes.idUsuario]">
                                <tr>
                                    <td [attr.colspan]="3 + +diasMes.length" class="titulo">
                                        Roca: {{roca.nombreRoca}}</td>
                                </tr>
                                <ng-container *ngIf="actividades[participantes.idUsuario][roca.idRoca];">
                                    <tr *ngFor="let act of actividades[participantes.idUsuario][roca.idRoca][0]">
                                        <td style="vertical-align: middle; justify-content: center;">
                                            <img [src]="'http://localhost:8080/imgs/usuarios/' + roca.imagenUsuario"
                                                class="pfp d-none d-xl-block d-xxl-block"
                                                title="{{roca.nombreUsuario}} {{roca.apellidoUsuario}}">
                                        </td>
                                        <td title="{{act.nombreActividad}}">{{act.nombreActividad}}</td>
                                        <td style="text-align: center; vertical-align: middle;">
                                            {{porcentaje[participantes.idUsuario][act.idActividad] || 0}}%</td>
                                        <ng-container
                                            *ngFor="let st of status[participantes.idUsuario][act.idActividad]; let i = index">
                                            <td [ngStyle]="{
                                    'background-color': st == null ? 'white' : st == 'Planeado' ? 'rgb(187, 187, 187)' : 'green'
                                  }"></td>
                                        </ng-container>
                                    </tr>
                                </ng-container>
                                <ng-container *ngIf="!actividades[participantes.idUsuario][roca.idRoca]">
                                    <tr>
                                        <td [attr.colspan]="3 + +diasMes.length"> Aún no hay actividades</td>
                                    </tr>
                                </ng-container>
                            </ng-container>
                            <tr>
                                <td [attr.colspan]="3 + +diasMes.length" class="titulo">Actividades secundarias</td>
                            </tr>
                            <ng-container *ngFor="let secundarias of actividadesSecundarias[participantes.idUsuario]">
                                <tr>
                                    <td style="vertical-align: middle; justify-content: center;"><img
                                            [src]="'http://localhost:8080/imgs/usuarios/' + rocas[participantes.idUsuario][0].imagenUsuario"
                                            class="pfp d-none d-xl-block d-xxl-block"
                                            title="{{rocas[participantes.idUsuario][0].nombreUsuario}} {{rocas[participantes.idUsuario][0].apellidoUsuario}}">
                                    </td>
                                    <td> {{secundarias.nombreActividad}}</td>
                                    <td style="vertical-align: middle; text-align: center;">
                                        {{porcentaje[participantes.idUsuario][secundarias.idActividad] || 0}}%</td>
                                    <ng-container
                                        *ngFor="let st of status[participantes.idUsuario]['Sin roca'][secundarias.idActividad]; let i = index">
                                        <td title="{{diaSeleccionado}}" [ngStyle]="{
                                            'background-color': st == null ? 'white' : st == 'Planeado' ? 'rgb(187, 187, 187)' : 'green'
                                          }"></td>
                                    </ng-container>
                                </tr>
                            </ng-container>
                        </tbody>
                    </table>
                </div>
            </div>
        </ng-container>
    </div>

    <ng-template #crearRocaModal class="modal fade">
        <div class="modal-content">
            <form id="nuevoIndicador">
                <div class="modal-header">
                    <h4 class="modal-title">Nueva Roca</h4>
                    <button type="button" class="close" (click)="cerrarModal()">X</button>
                </div>
                <div class="modal-body">
                    <div class="form-group">
                        <label>Nombre</label>
                        <input type="text" class="form-control" id="nombreProyecto" name="proyecto" required
                            [(ngModel)]="roca.nombreRoca">
                    </div>

                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-default" (click)="cerrarModal()">Cancelar</button>
                    <button type="button" class="btn btn-success" (click)="crearRoca()">Agregar</button>
                </div>
            </form>
        </div>
    </ng-template>

    <ng-template #crearActividadModal class="modal fade">
        <div class="modal-content">
            <form id="nuevoIndicador">
                <div class="modal-header">
                    <h4 class="modal-title">Nueva Actividad</h4>
                    <button type="button" class="close" (click)="cerrarModal()">X</button>
                </div>
                <div class="modal-body">
                    <div class="form-group">
                        <label>Nombre</label>
                        <input type="text" class="form-control" id="nombreProyecto" name="proyecto" required
                            [(ngModel)]="actividad.nombreActividad">
                    </div>
                    <div class="form-group ">
                        <label>Roca</label>
                        <ng-select name="idRoca" class="custom-select" [(ngModel)]="actividad.idRoca">
                            <ng-option *ngFor="let options of rocas[idUsuario]" [value]="options.idRoca">
                                <div class="option-content">
                                    <span>{{options.nombreRoca}}</span>
                                </div>
                            </ng-option>
                            <ng-option value="Sin roca">
                                <div class="option-content">
                                    <span>Sin roca</span>
                                </div>
                            </ng-option>
                        </ng-select>
                    </div>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-default" (click)="cerrarModal()">Cancelar</button>
                    <button type="button" class="btn btn-success" (click)="crearActividad()">Agregar</button>
                </div>
            </form>
        </div>
    </ng-template>

    <ng-template #planearActividadModal class="modal fade">
        <div class="modal-content">
            <form id="planear">
                <div class="modal-header">
                    <h3 class="modal-title">Actividad: {{nombre}}</h3>
                    <button type="button" class="close" (click)="cerrarModal()">X</button>
                </div>
                <div class="modal-body">
                    <label>Fecha: {{diaSeleccionado}}</label>
                    <div class="row">
                        <div class="form-group form-check col-md-6 ml-3">
                            <label for="mostrarAcumulado" class="form-check-label">Planear</label>
                            <input type="checkbox" class="form-check-input" id="planear" name="planear"
                                [(ngModel)]="statAct" (change)="planear()">
                        </div>
                        <div class="form-group form-check col-md-6" *ngIf="statAct == true">
                            <label for="mostrarReal" class="form-check-label">Marcar como completado</label>
                            <input type="checkbox" class="form-check-input" id="completar" name="completar"
                                [(ngModel)]="completado" (change)="completar()">
                        </div>
                    </div>
                </div>
                <div class=" modal-footer">
                    <button type="button" class="btn btn-default" (click)="cerrarModal()">Cancelar</button>
                </div>
            </form>
        </div>
    </ng-template>

    <ng-template #editarRocaModal class="modal fade">
        <div class="modal-content">
            <form id="editarMeta">
                <div class="modal-header">
                    <h4 class="modal-title">Editar Roca</h4>
                    <button type="button" class="close" (click)="cerrarModal()">X</button>
                </div>
                <div class="modal-body">
                    <div class="form-group">
                        <label>Nombre Roca</label>
                        <input type="text" class="form-control" id="nombreIndicador" name="nombreIndicador" required
                            [(ngModel)]="auxNombre">
                    </div>
                    <div class="form-group">
                        <button class="btn btn-danger mt-3" (click)="archivarRoca()">Archivar</button>
                    </div>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-default" (click)="cerrarModal()">Cancelar</button>
                    <button type="button" class="btn btn-success" (click)="editarRoca()">Editar</button>
                </div>
            </form>
        </div>
    </ng-template>

    <ng-template #editarActividadModal class="modal fade">
        <div class="modal-content">
            <form id="editarMeta">
                <div class="modal-header">
                    <h4 class="modal-title">Editar Actividad</h4>
                    <button type="button" class="close" (click)="cerrarModal()">X</button>
                </div>
                <div class="modal-body">
                    <div class="form-group">
                        <label>Nombre Actividad</label>
                        <input type="text" class="form-control" id="nombreIndicador" name="nombreIndicador" required
                            [(ngModel)]="actividad.nombreActividad">
                    </div>
                    <div class="form-group">
                        <button class="btn btn-danger mt-3" (click)="archivarActividad()">Archivar</button>
                    </div>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-default" (click)="cerrarModal()">Cancelar</button>
                    <button type="button" class="btn btn-success" (click)="editarActividad()">Editar</button>
                </div>
            </form>
        </div>
    </ng-template>